/*
   "1stdiffeqn.mm"
   Simulation of the following system:
   dx/dt = -2 x, x(0)=5
*/

Func void main()
{
	Real t0,t1;
	Real h,dtsav;
	Matrix x0,TC,XC,UC;
	void diff_eqs(),link_eqs();

	t0 = 0.0;  //V~[V̊Jn t=0 ɂ
	t1 = 10.0;  //V~[V̏I t=10 ɂ

	x0 = [5.0];  //Ԃ x(0)=5.0 ɂ

	h = 5.0e-4; // V~[V̍0.5msecɂ
	dtsav = 1.0e-3;// f[^1msecɕۑ

	print "Now simulating\n";

// Ode()ɂăV~[Vs
	{TC, XC, UC} = Ode(t0, t1, x0, diff_eqs, link_eqs, h, dtsav);
// diff_eqs() ͔Lq֐
// link_eqs() ͕̔̊֌WLq֐
// TC: Ԃ̎n
// XC: x(t)̎n
// UC: o̓xNg̎n

//l\D t, c x(t)
	mgplot(1,Array(TC),Array(XC));

	print TC >> "TC.ode";
	print XC >> "XC.ode";
	print UC >> "UC.ode";
}

// diff_eqs() ͔Lq֐
Func void diff_eqs(DX,t,X,UY)
Real t;
Matrix X,DX,UY;
{
	Matrix xp,up,dxp;

	xp = X; // X x(t)\ĂD

	up = UY; //UY͎gpȂ

	dxp = -2 * xp; //

	DX = [dxp]; //ŌɑxDXɓn
}

// link_eqs() ͕̔̊֌WLq֐
Func void link_eqs(UY,t,X)
Real t;
Matrix UY,X;
{
	Matrix xp,up;

	xp = X; // X x(t)\ĂD

// ŌUYɎt̒lnDƂ肠x(t)ĂD
	UY = [xp];

}

